
Database - Bug #2591

incorrect queries when MATCH operator is involved

06/19/2015 11:06 AM - Ovidiu Maxiniuc

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Ovidiu Maxiniuc % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stablization for Server

Features

  

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 06/19/2015 11:22 AM - Ovidiu Maxiniuc

One test (CUSTOMER_SITE_7) of in the customer's testing batch was failing (not finding the record) for unknown reasons.

After investigations, I observed that the only distinctive feature of both the field and the pattern we were looking for was that they both were ending by

spaces. Same number, so the query should have matched.

Looking into the generated SQL code, I noted that the field was rtrimmed. The analysis with testcases on P4GL test machines proved that we should

not do the rtrim in this case (see testcases/uast/begins-matches4.p).

I checked the BEGIN operator too, and the same rule applies.

To fix this issue, I chose to check the grandparent of the node to be rtrimmed in HQLPreprocessor and if in one of the two cases above, the rtrim

function is not inserted any more. With this change, both my testcase and original customer application testcase passed.

#2 - 06/19/2015 01:01 PM - Ovidiu Maxiniuc

For review, this is branch 2591a/, at revision 10882.

#3 - 06/20/2015 12:11 AM - Eric Faulhaber

- Status changed from WIP to Test

- Assignee set to Ovidiu Maxiniuc

Nice work tracking this down quickly and fixing it. 10882 on branch looks good. Please regression test. I'll run unit tests.

#4 - 06/22/2015 04:01 PM - Ovidiu Maxiniuc

- Assignee deleted (Ovidiu Maxiniuc)

- Status changed from Test to WIP

The 1st round of testing just ended. There are a lot (17) of failures in gso_ctrlc_tests and some in tc_tests (11 including dependencies). I am

restarting it.
#5 - 06/22/2015 04:02 PM - Ovidiu Maxiniuc

- Assignee set to Ovidiu Maxiniuc

#6 - 06/23/2015 03:57 PM - Ovidiu Maxiniuc

Taking into account the changes involved, I deem the update passed the regression testing. It looks like it did well in the ETF so I guess it is ready for

commit.

#7 - 06/23/2015 04:17 PM - Eric Faulhaber

Please commit.

#8 - 06/23/2015 05:01 PM - Ovidiu Maxiniuc

Committed to bzr as revno 10886.

#9 - 07/16/2015 04:46 PM - Eric Faulhaber

- Status changed from WIP to Closed

- % Done changed from 0 to 100

#10 - 11/16/2016 12:06 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features
